import { LRParser } from '@lezer/lr';
import { syntaxTree, LRLanguage, LanguageSupport } from '@codemirror/language';
import { Tag, styleTags, tags } from '@lezer/highlight';
import { linter } from '@codemirror/lint';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 14,
  states: "nQVQPOOOOQO'#Cg'#CgOOQO'#Cc'#CcQVQPOOOOQO-E6a-E6a",
  stateData: "h~OYOS~OQPORPOSPOTPOUPO~O",
  goto: "g[PPPPPPP]PPPcQRORSRTQOR",
  nodeNames: "⚠ Program Chord MetaData Bracket Comment String",
  maxTerm: 11,
  skippedNodes: [0],
  repeatNodeCount: 1,
  tokenData: "2[~RXXYnYZn]^npqnrss!P!Q$P!}#O$b#P#Q,y#o#p-O~sOY~~vUpqsqrsrs!Ys#Os#O#P!_#P~s~!_OU~~!bXrss!P!Qs#O#Ps#U#Vs#Y#Zs#b#cs#f#gs#h#is#i#j!}~#QR!Q![#Z!c!i#Z#T#Z#Z~#^R!Q![#g!c!i#g#T#Z#g~#jR!Q![#s!c!i#s#T#Z#s~#vR!Q![s!c!is#T#Zs~$SP!P!Q$V~$[QT~OY$VZ~$V~$gXS~st%S!P!Q&b!R!Y%`!c!j*r!k!l&m!x!y*P#U#V%S#l#m&b#p#q,j~%VR!R!Y%`!k!l&m!x!y*P~%cWst%`xy%`yz%`!P!Q%{!Q![%`!c!}%`#P#Q&h#T#o%`~&OSst&[!R!Y&b#U#V&[#p#q&[~&_P!R!Y&b~&eP#P#Q&h~&mOQ~~&p[st'fxy'fyz'f!P!Q(R!Q!['f!c!k'f!k!l)^!l!x'f!x!y'f!y!}'f#P#Q&h#T#o'f~'iWst'fxy'fyz'f!P!Q(R!Q!['f!c!}'f#P#Q&h#T#o'f~(UTst(e!k!l(n!x!y)T#U#V(e#p#q(e~(hQ!k!l(n!x!y)T~(qR!k!l(z!x!y&b#P#Q&h~(}Q!k!l&b#P#Q&h~)WQ!k!l(z#P#Q&h~)aYst'fxy'fyz'f!P!Q(R!Q!['f!c!k'f!k!l'f!l!}'f#P#Q&h#T#o'f~*SYst'fxy'fyz'f!P!Q(R!Q!['f!c!k'f!k!l)^!l!}'f#P#Q&h#T#o'f~*uZst+hxy+hyz+h!P!Q,T!Q![+h!c!}+h#P#Q&h#T#U+h#U#V+h#V#o+h#p#q+h~+kWst+hxy+hyz+h!P!Q,T!Q![+h!c!}+h#P#Q&h#T#o+h~,WP!c!j,Z~,^Sst&b#P#Q&h#U#V&b#p#q&b~,mS!R!Y%`!k!l&m!x!y*P#P#Q&h~-OOS~~-RVpq-Oqr-Os![-O![!]-h!]#O-O#O#P0j#P~-O~-kXpq-hqr-hs![-h![!]-h!]#O-h#O#P.W#P#q-h#q#r/x#r~-h~.ZXrs-h!P!Q-h#O#P-h#U#V-h#Y#Z-h#b#c-h#f#g-h#h#i-h#i#j.v~.yR!Q![/S!c!i/S#T#Z/S~/VR!Q![/`!c!i/`#T#Z/`~/cR!Q![/l!c!i/l#T#Z/l~/oR!Q![-h!c!i-h#T#Z-h~/}XR~pq-hqr-hs![-h![!]-h!]#O-h#O#P.W#P#q-h#q#r/x#r~-h~0mXrs-O!P!Q-O#O#P-O#U#V-O#Y#Z-O#b#c-O#f#g-O#h#i-O#i#j1Y~1]R!Q![1f!c!i1f#T#Z1f~1iR!Q![1r!c!i1r#T#Z1r~1uR!Q![2O!c!i2O#T#Z2O~2RR!Q![-O!c!i-O#T#Z-O",
  tokenizers: [0],
  topRules: {"Program":[0,1]},
  tokenPrec: 0
});

const exampleStringLinter = linter((view) => {
  let diagnostics = [];
  syntaxTree(view.state).cursor().iterate((node) => {
    if (node.name == "String")
      diagnostics.push({
        from: node.from,
        to: node.to,
        severity: "warning",
        message: "Stings are forbidden",
        actions: [{
          name: "Remove",
          apply(view2, from, to) {
            view2.dispatch({ changes: { from, to } });
          }
        }]
      });
  });
  return diagnostics;
});

const customTags = {
  chord: Tag.define()
};
const ChordProLanguage = LRLanguage.define({
  parser: parser.configure({
    props: [
      styleTags({
        Chord: customTags.chord,
        MetaData: tags.meta,
        Comment: tags.comment,
        Bracket: tags.squareBracket,
        String: tags.string
      })
    ]
  }),
  languageData: {
    commentTokens: { line: "//" }
  }
});
function ChordPro() {
  return new LanguageSupport(ChordProLanguage);
}

export { ChordPro, ChordProLanguage, customTags, exampleStringLinter };
